﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SimpleDataBinding
{
    public partial class FormMain : Form
    {
        Data data = new Data();
        public FormMain()
        {
            InitializeComponent();
            InitBindings(data);
        }

        //Only changes the actual control property. One text box changes value.
        private void buttonProperty_Click(object sender, EventArgs e)
        {
            textBoxName1.Text = "Change Property";
        }

        //Change the value of the binding property. All text boxes change value.
        private void buttonBindingProperty_Click(object sender, EventArgs e)
        {
            ((Data)BindingManager.Current).FullName = "Change Binding Property";
        }

        //Change data class. All text boxes change.
        private void buttonChangeData_Click(object sender, EventArgs e)
        {
            data.FullName = "Change Data";
        }

        //Make change in custom text box.
        private void buttonPropertyMyTextBox_Click(object sender, EventArgs e)
        {
            myTextBoxName1.Text = "MyText Property";
        }

        //Fire validating event in custom text box. Validating event changes binding source.
        private void buttonFireTextChanged_Click(object sender, EventArgs e)
        {
            myTextBoxName1.CallValidating(e);
        }

        BindingManagerBase BindingManager
        {
            get
            {
                return this.BindingContext[this.data];
            }
        }

        String fullName;
        public String FullName { 
            get { return fullName; }
            set { 
                fullName = value;
                Console.WriteLine("Form FullName: {0}", fullName);
            }
        }

        private void InitBindings(Data data)
        {
            //All text boxes are bound to the same data.
            this.textBoxName1.DataBindings.Add("Text", data, "FullName");
            this.textBoxName2.DataBindings.Add("Text", data, "FullName");
            this.myTextBoxName1.DataBindings.Add("Text", data, "FullName");
            this.myTextBoxName2.DataBindings.Add("Text", data, "FullName");
            this.DataBindings.Add("FullName", data, "FullName");

        }

        private void ClearBindings()
        {
            this.textBoxName1.DataBindings.Clear();
            this.textBoxName2.DataBindings.Clear();
            this.myTextBoxName1.DataBindings.Clear();
            this.myTextBoxName2.DataBindings.Clear();
            this.DataBindings.Clear();
        }

        private void buttonFormProperty_Click(object sender, EventArgs e)
        {
            this.FullName = "Form Property";
        }

    }
}
